//-----------------------------------------------------
//File: lcd_4bit.h
//Auth: ELECTRONIC ASSEMBLY JM
//DATE: 08-07-2012
//-----------------------------------------------------
#ifndef LCD4BIT_H
#define LCD4BIT_H

//#define DIP203_4
#define DIP203_6

//--- Port definitions for 8 bit port ---
#define RS 		p6_0
#define ddRS	pd6_0
#define RW		p6_1
#define ddRW	pd6_1
#define EN		p6_2
#define ddEN	pd6_2

//databits are p0_4 to p0_7, leave p0_0 to p0_3 as inputs
#define DATA	p0
#define ddDATA	pd0

//--- Standard definitions for LCD ---
#define LCD_HOME_L1	0x80
#define LINE1	0
//HD44780
#define LINE2	LINE1+0x40
#define LINE3	LINE1+0x14
#define	LINE4 	LINE2+0x14
//Character table
#define ROMA 0x00
#define ROMB 0x04
#define ROMC 0x08
#define CG0 0x00  //240 char from CGRom, 8 CGRam (8 free definable chars)
#define CG1 0x01  //248 char from CGRom, 8 CGRam (8 free definable chars)
#define CG2 0x02  //250 char from CGRom, 8 CGRam (6 free definable chars)
#define CG3 0x03  //256 char from CGRom, 8 CGRam (0 free definable chars) ->interesting for ROMC

#define DISPLAY_ON 	0x04
#define DISPLAY_OFF 0xFB
#define CURSOR_ON	0x02
#define CURSOR_OFF	0xFD
#define BLINK_ON	0x01
#define BLINK_OFF	0xFE



void initDispl(void);


void WriteChar		(char character);
void WriteString	(_far char * string);
void SetSymb 		(char add, char data);
void SetPostion		(char pos);
void DisplayOnOff	(char data);
void ClrDisplay		(void);
void DefineCharacter(unsigned char postion, unsigned char *data);
#define GETCURSORADDR()	CheckBusy();

//Normally you don't need these functions outside this module
static void WriteIns		(char ins);
static void WriteData		(char data);
static void WriteNibble		(char data);

unsigned char CheckBusy		(void);

#endif